// Code generated by go-swagger; DO NOT EDIT.

package directory

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateDirectoryParams creates a new CreateDirectoryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateDirectoryParams() *CreateDirectoryParams {
	return &CreateDirectoryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateDirectoryParamsWithTimeout creates a new CreateDirectoryParams object
// with the ability to set a timeout on a request.
func NewCreateDirectoryParamsWithTimeout(timeout time.Duration) *CreateDirectoryParams {
	return &CreateDirectoryParams{
		timeout: timeout,
	}
}

// NewCreateDirectoryParamsWithContext creates a new CreateDirectoryParams object
// with the ability to set a context for a request.
func NewCreateDirectoryParamsWithContext(ctx context.Context) *CreateDirectoryParams {
	return &CreateDirectoryParams{
		Context: ctx,
	}
}

// NewCreateDirectoryParamsWithHTTPClient creates a new CreateDirectoryParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateDirectoryParamsWithHTTPClient(client *http.Client) *CreateDirectoryParams {
	return &CreateDirectoryParams{
		HTTPClient: client,
	}
}

/* CreateDirectoryParams contains all the parameters to send to the API endpoint
   for the create directory operation.

   Typically these are written to a http.Request.
*/
type CreateDirectoryParams struct {

	/* Directory.

	   path to target directory
	*/
	Directory string

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Op.

	   the operation for the api

	   Default: "create-directory"
	*/
	Op string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create directory params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateDirectoryParams) WithDefaults() *CreateDirectoryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create directory params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateDirectoryParams) SetDefaults() {
	var (
		opDefault = string("create-directory")
	)

	val := CreateDirectoryParams{
		Op: opDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the create directory params
func (o *CreateDirectoryParams) WithTimeout(timeout time.Duration) *CreateDirectoryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create directory params
func (o *CreateDirectoryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create directory params
func (o *CreateDirectoryParams) WithContext(ctx context.Context) *CreateDirectoryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create directory params
func (o *CreateDirectoryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create directory params
func (o *CreateDirectoryParams) WithHTTPClient(client *http.Client) *CreateDirectoryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create directory params
func (o *CreateDirectoryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDirectory adds the directory to the create directory params
func (o *CreateDirectoryParams) WithDirectory(directory string) *CreateDirectoryParams {
	o.SetDirectory(directory)
	return o
}

// SetDirectory adds the directory to the create directory params
func (o *CreateDirectoryParams) SetDirectory(directory string) {
	o.Directory = directory
}

// WithNamespace adds the namespace to the create directory params
func (o *CreateDirectoryParams) WithNamespace(namespace string) *CreateDirectoryParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the create directory params
func (o *CreateDirectoryParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithOp adds the op to the create directory params
func (o *CreateDirectoryParams) WithOp(op string) *CreateDirectoryParams {
	o.SetOp(op)
	return o
}

// SetOp adds the op to the create directory params
func (o *CreateDirectoryParams) SetOp(op string) {
	o.Op = op
}

// WriteToRequest writes these params to a swagger request
func (o *CreateDirectoryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param directory
	if err := r.SetPathParam("directory", o.Directory); err != nil {
		return err
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// query param op
	qrOp := o.Op
	qOp := qrOp
	if qOp != "" {

		if err := r.SetQueryParam("op", qOp); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
