// Code generated by go-swagger; DO NOT EDIT.

package namespace_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWatchNamespaceServiceRevisionParams creates a new WatchNamespaceServiceRevisionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWatchNamespaceServiceRevisionParams() *WatchNamespaceServiceRevisionParams {
	return &WatchNamespaceServiceRevisionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWatchNamespaceServiceRevisionParamsWithTimeout creates a new WatchNamespaceServiceRevisionParams object
// with the ability to set a timeout on a request.
func NewWatchNamespaceServiceRevisionParamsWithTimeout(timeout time.Duration) *WatchNamespaceServiceRevisionParams {
	return &WatchNamespaceServiceRevisionParams{
		timeout: timeout,
	}
}

// NewWatchNamespaceServiceRevisionParamsWithContext creates a new WatchNamespaceServiceRevisionParams object
// with the ability to set a context for a request.
func NewWatchNamespaceServiceRevisionParamsWithContext(ctx context.Context) *WatchNamespaceServiceRevisionParams {
	return &WatchNamespaceServiceRevisionParams{
		Context: ctx,
	}
}

// NewWatchNamespaceServiceRevisionParamsWithHTTPClient creates a new WatchNamespaceServiceRevisionParams object
// with the ability to set a custom HTTPClient for a request.
func NewWatchNamespaceServiceRevisionParamsWithHTTPClient(client *http.Client) *WatchNamespaceServiceRevisionParams {
	return &WatchNamespaceServiceRevisionParams{
		HTTPClient: client,
	}
}

/* WatchNamespaceServiceRevisionParams contains all the parameters to send to the API endpoint
   for the watch namespace service revision operation.

   Typically these are written to a http.Request.
*/
type WatchNamespaceServiceRevisionParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* RevisionGeneration.

	   target revision generation
	*/
	RevisionGeneration string

	/* ServiceName.

	   target service name
	*/
	ServiceName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the watch namespace service revision params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WatchNamespaceServiceRevisionParams) WithDefaults() *WatchNamespaceServiceRevisionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the watch namespace service revision params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WatchNamespaceServiceRevisionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) WithTimeout(timeout time.Duration) *WatchNamespaceServiceRevisionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) WithContext(ctx context.Context) *WatchNamespaceServiceRevisionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) WithHTTPClient(client *http.Client) *WatchNamespaceServiceRevisionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) WithNamespace(namespace string) *WatchNamespaceServiceRevisionParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithRevisionGeneration adds the revisionGeneration to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) WithRevisionGeneration(revisionGeneration string) *WatchNamespaceServiceRevisionParams {
	o.SetRevisionGeneration(revisionGeneration)
	return o
}

// SetRevisionGeneration adds the revisionGeneration to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) SetRevisionGeneration(revisionGeneration string) {
	o.RevisionGeneration = revisionGeneration
}

// WithServiceName adds the serviceName to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) WithServiceName(serviceName string) *WatchNamespaceServiceRevisionParams {
	o.SetServiceName(serviceName)
	return o
}

// SetServiceName adds the serviceName to the watch namespace service revision params
func (o *WatchNamespaceServiceRevisionParams) SetServiceName(serviceName string) {
	o.ServiceName = serviceName
}

// WriteToRequest writes these params to a swagger request
func (o *WatchNamespaceServiceRevisionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param revisionGeneration
	if err := r.SetPathParam("revisionGeneration", o.RevisionGeneration); err != nil {
		return err
	}

	// path param serviceName
	if err := r.SetPathParam("serviceName", o.ServiceName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
